import sqlite3
from math import *
from operator import itemgetter
#INITIATING LISTS USED IN THE PROGRAM FROM THE DATABASE
conn=sqlite3.connect('C:/Python34/data/mydb.db')
cursor=conn.cursor()
#creating the time list
cursor.execute("""SELECT Time FROM EnergyProduction""")
listtime = cursor.fetchall()
#creating for each energy resource the list of power production for each time of the day
cursor.execute("""SELECT P_solar FROM EnergyProduction""")
listPs = cursor.fetchall()
cursor.execute("""SELECT P_wind FROM EnergyProduction""")
listPw = cursor.fetchall()
cursor.execute("""SELECT P_hydro FROM EnergyProduction""")
listPh = cursor.fetchall()
cursor.execute("""SELECT P_maingrid FROM EnergyProduction""")
listPmg = cursor.fetchall()
#creating for each energy resource the list of their power volume use for each time of the day
cursor.execute("""SELECT P_solar FROM PowerUse""")
listPUs = cursor.fetchall()
cursor.execute("""SELECT P_wind FROM PowerUse""")
listPUw = cursor.fetchall()
cursor.execute("""SELECT P_hydro FROM PowerUse""")
listPUh = cursor.fetchall()
cursor.execute("""SELECT P_ev FROM PowerUse""")
listPUev = cursor.fetchall()
cursor.execute("""SELECT P_maingrid FROM PowerUse""")
listPUmg = cursor.fetchall()
#creating for each appliance a list of their power consumption for each time of the day
cursor.execute("""SELECT P_mustrun FROM EnergyConsumption""")
listPmr = cursor.fetchall()
cursor.execute("""SELECT P_dishwasher FROM EnergyConsumption""")
listPdish = cursor.fetchall()
cursor.execute("""SELECT P_wash FROM EnergyConsumption""")
listPwash = cursor.fetchall()
cursor.execute("""SELECT P_EV FROM EnergyConsumption""")
listPev = cursor.fetchall()
#creating for each storage a list of their battery level for each time of the day
cursor.execute("""SELECT EV FROM BatteryLevel""")
listbattev = cursor.fetchall()
cursor.execute("""SELECT HYDRO FROM BatteryLevel""")
listbatth = cursor.fetchall()
#creating for each energy resource the list of cost for each time of the day
cursor.execute("""SELECT CostSolar FROM PricingScheme""")
listCs = cursor.fetchall()
cursor.execute("""SELECT CostWind FROM PricingScheme""")
listCw = cursor.fetchall()
cursor.execute("""SELECT CostHydro FROM PricingScheme""")
listCh = cursor.fetchall()
cursor.execute("""SELECT CostMainGrid FROM PricingScheme""")
listCmg = cursor.fetchall()
cursor.execute("""SELECT CostEV FROM PricingScheme""")
listCev = cursor.fetchall()
#all the information is now stored in the lists... we can close the database access
conn.commit()
conn.close()
#Unfortunately the information has been extracted as lists of tuples. In order to be able to modify these lists in the future, we need to remove the tuples
timeframe = []
for index in range(len(listtime)):
    timeframe.append(listtime[index][0])
#First for the energy sources...
Psolar0 = []
for index in range(len(listPs)):
    Psolar0.append(listPs[index][0])
Psolar = Psolar0
Pwind0 = []
for index in range(len(listPw)):
    Pwind0.append(listPw[index][0]*3)
Pwind = Pwind0
Phydro = []
for index in range(len(listPh)):
    Phydro.append(listPh[index][0])
Pev1 = []
for index in range(len(listbattev)):
    Pev1.append(0)
Pev2 = []
for index in range(len(listbattev)):
    Pev2.append(0)
Pmg0 = []
for index in range(len(listPmg)):
    Pmg0.append(listPmg[index][0])
Pmg = Pmg0
#...then for the energy use...
PUsolar = []
for index in range(len(listPUs)):
    PUsolar.append(listPUs[index][0])
PUwind = []
for index in range(len(listPUw)):
    PUwind.append(listPUw[index][0])
PUhydro = []
for index in range(len(listPUh)):
    PUhydro.append(listPUh[index][0])
PUev1 = []
for index in range(len(listPUev)):
    PUev1.append(listPUev[index][0])
PUev2 = []
for index in range(len(listPUev)):
    PUev2.append(listPUev[index][0])
PUmg = []
for index in range(len(listPUmg)):
    PUmg.append(listPUmg[index][0])
#...then for the battery levels...
batteryEV1 = []
for index in range(len(listbattev)):
    batteryEV1.append(listbattev[index][0])
batteryEV2 = []
for index in range(len(listbattev)):
    batteryEV2.append(listbattev[index][0])
batteryHydro = []
for index in range(len(listbatth)):
    batteryHydro.append(listbatth[index][0])  
#...then for the energy consumption...
Pmr = []
for index in range(len(listPmr)):
    Pmr.append(listPmr[index][0])
Pdish = []
for index in range(len(listPdish)):
    Pdish.append(listPdish[index][0])
Pwash = []
for index in range(len(listPwash)):
    Pwash.append(listPwash[index][0])
ev1P = []
for index in range(len(listPev)):
    ev1P.append(listPev[index][0])
ev2P = []
for index in range(len(listPev)):
    ev2P.append(listPev[index][0]) 
#...and finally for the energy costs    
csolar = []
for index in range(len(listCs)):
    csolar.append(listCs[index][0])
cwind = []
for index in range(len(listCw)):
    cwind.append(listCw[index][0])
chydro = []
for index in range(len(listCh)):
    chydro.append(listCh[index][0])
cev = []
for index in range(len(listCev)):
    cev.append(listCev[index][0])
cmg = []
for index in range(len(listCmg)):
    cmg.append(listCmg[index][0])
cavg = []
for index in range(len(listCmg)):
    cavg.append(0)
print("Lists containing information are: timeframe, Psolar, Pwind, Phydro, Pev1, Pev2, Pmg, PUsolar, PUwind, PUhydro, PUev1, PUev2, PUmg, Pmr, Pdish, Pwash, ev1P, ev2P, batteryEV1, batteryEV2, batteryHydro, csolar, cwind, chydro, cev, cmg, cavg")
# DEFINING USEFUL TIME VARIABLES AND FUNCTIONS
timestepm = 10 #timestep in minutes
timesteph = timestepm/60 #timestep in hours
# to deal with the fact that timesteph is not a round number 
def hconversion(minutetime):
    hourtime = minutetime/60
    return hourtime
#a rounding conversion function is created:
def mconversion(hourtime):
    minutetime = 60*int(hourtime)+10*int((hourtime-int(hourtime))*60/10)
    return minutetime
#function to round a time to its lower tens minutes:
def floor10(minutetime):
    newtime = floor(minutetime/10)*10
    return newtime
#function to round a time to its upper tens minutes:
def ceil10(minutetime):
    newtime = ceil(minutetime/10)*10
    return newtime
#function to round a time to tens minutes:
def round10(minutetime):
    newtime = round(minutetime/10)*10
    return newtime
#
#PRICING SCHEMES
#new power list are created to ensure this attributes won't be modified later in the simulation.
PAsolar = Psolar
PAwind = Pwind
PAhydro = Phydro
PAmg = Pmg
PAcmg = cmg
#creation of the class
class PricingScheme:
    def __init__(self, costtype, costlist, PAlist):
        self.costtype = costtype
        self.costlist = costlist
        self.PAlist = PAlist
    def constant(self, cvalue):
        for timeindex in range(len(timeframe)):
            self.costlist[timeindex] = cvalue
    def proportional(self, factor):
        for timeindex in range(len(timeframe)):
            self.costlist[timeindex] = factor * self.PAlist[timeindex]
    def weighted(self, factor):
        for timeindex in range(len(timeframe)):
            if (factor/self.PAlist[timeindex] > 0.5):
                self.costlist[timeindex] = 0.5
            else:
                self.costlist[timeindex] = factor / self.PAlist[timeindex]
    def fee(self, factor):
        for timeindex in range(len(timeframe)):
            self.costlist[timeindex] += factor
#creating the instances
solarc = PricingScheme("solar", csolar, PAsolar)
windc = PricingScheme("wind", cwind, PAwind)
hydroc = PricingScheme("hydro", chydro, PAhydro)
mgc = PricingScheme("maingrid", cmg, PAmg)
evc = PricingScheme("EV", cev, PAcmg)
avgc = PricingScheme("average", cavg, PAcmg)
#USING CONSTANT VALUES
solarc.constant(0)
windc.weighted(1000)
hydroc.constant(0.27)
avgc.proportional(1.1)
evc.constant(0)
mgc.fee(0.1)
#saving the new pricing schemes
csolar = solarc.costlist
cwind = windc.costlist
chydro = hydroc.costlist
cmg = mgc.costlist
cev = evc.costlist
cavg = avgc.costlist
#
#CREATING THE POWER PRODUCTION OBJECTS
#creation of the class
class PowerAvailable:
    #defining the power resources
    def __init__(self, resourcetype, PAlist, PUlist, costlist):
        self.resourcetype = resourcetype
        self.PAlist = PAlist #list in kW
        self.PUlist = PUlist #list in kW
        self.costlist = costlist #list in NOK/kWh
   #When some power volume has been used, the potential power production must be reduced
    def updatePower(self, timeindex, Pused):
        self.PAlist[timeindex] += Pused
    #When some power volume has been used from the energy source, is must be added to the power use table.
    def createResourceUse(self, timeindex, Pused):
        self.PUlist[timeindex] += Pused
#Creation of the three class' instances
solarpower = PowerAvailable("solar", Psolar, PUsolar, csolar) 
windpower = PowerAvailable("wind", Pwind, PUwind, cwind)
mgpower = PowerAvailable("maingrid", Pmg, PUmg, cmg) 
print("Instances of the class PowerAvailable are solarpower, windpower, mgpower, hydropower, EV1 and EV2")
#
#CREATION OF THE STORAGE CHILD CLASS:
#creation of the class
class Storage(PowerAvailable):
    def __init__(self, resourcetype, PAlist, PUlist, costlist, battery, ratedpower):
        PowerAvailable.__init__(self, resourcetype, PAlist, PUlist, costlist)
        self.battery = battery #list in kWh
        self.ratedpower = ratedpower # real in kW
    # the first value of the battery and power potential is defined there
    def initialisation(self, timeindex, batt0):
        self.battery[timeindex] = batt0
        if (self.battery[timeindex]/(timesteph)) >= self.ratedpower:
            self.PAlist[timeindex] = self.ratedpower
        else: 
            self.PAlist[timeindex] = self.battery[timeindex]/timesteph
        if timeframe[timeindex] <= 1430:
            self.battery[timeindex+1] = self.battery[timeindex]
            self.PAlist[timeindex+1] = self.PAlist[timeindex]
    #The battery level must be updated every time
    def updatebattery(self, timeindex, Pnew):
        self.battery[timeindex] += Pnew * (timesteph)
        if self.resourcetype == "EV":
            if self.battery[timeindex] > 17.5:
                self.battery[timeindex] = 17.5
            elif self.battery[timeindex] < 0:
                self.battery[timeindex] = 0
        if timeframe[timeindex] <= 1430:
            self.battery[timeindex+1] = self.battery[timeindex]
            if (self.battery[timeindex]/(timesteph)) >= self.ratedpower:
                self.PAlist[timeindex+1] = self.ratedpower
            else: 
                self.PAlist[timeindex+1] = self.battery[timeindex]/timesteph
#creation of the class' instance
hydropower = Storage("hydro", Phydro, PUhydro, chydro, batteryHydro, 224.18e6)
print("Instances of the class Storage are hydropower, EV1 and EV2")
#
#CREATING THE POWER CONSUMPTION OBJECTS
#creation of the class
class Appliance:
    # This class defines the different appliances of a typical household
    def __init__(self, apptype, power, duration, constraints, powerlist):
        self.apptype = apptype
        self.power = power # kW
        self.duration = duration # minutes
        self.constraints = constraints # list of time limits with the format hour.minutes: [tstart, tend]
        self.powerlist = powerlist
        self.condition = "passive" #states if the appliance is "passive", "waiting", "running" or "completed".   
    #turning the time limits in minutes ofr more accurate calculatons
    def timelimits(self, index):
        t1 = int(self.constraints[0])*60 + int((self.constraints[0]-int(self.constraints[0]))*100)
        t2 = int(self.constraints[1])*60 + int((self.constraints[1]-int(self.constraints[1]))*100)
        if index == 0:
            return t1
        elif index == 1:
            return t2
    #to trigger an appliance
    def ON(self, timeindex, batt_adjust):
        self.condition = "running"
        t0 = timeindex
        while (timeframe[t0] < timeframe[timeindex] + ceil10((self.duration - batt_adjust))):
            self.powerlist[t0] += self.power
            t0 += 1
            if t0 >= 144:
                break
        if timeframe[t0-1]<=1430:
            self.powerlist[t0] = -1
    #when an appliance is completed
    def OFF(self, timeindex):
        self.powerlist[timeindex] = 0
        self.condition = "passive"
#creation of class' instances
mustrun = Appliance("mustrun", "", "", "", Pmr)
dishwasher = Appliance("dishwasher", 1.200, 50, [8.30, 17.0], Pdish)
wash = Appliance("washingappliances", 2.700, 120, [14.0, 20.0], Pwash)
print("Instances of the class Appliance are mustrun, dishwasher, wash, EV1 and EV2")
#
#EVs are both consuming power and providing power...
class ElectricVehicle(Storage, Appliance):
    def __init__(self, apptype, resourcetype, power, ratedpower, duration, constraints, powerlist, PUlist, PAlist, costlist, battery):
        Storage.__init__(self, resourcetype, PAlist, PUlist, costlist, battery, ratedpower)
        Appliance.__init__(self, apptype, power, duration, constraints, powerlist)
    def disconnect(self, timeindex):
        self.condition = "passive"
        self.battery[timeindex] = "NA"
        self.PAlist[timeindex] = 0
        if timeframe[timeindex] <= 1430:
            self.battery[timeindex+1] = self.battery[timeindex]
            self.PAlist[timeindex+1] = self.PAlist[timeindex]
#create instances of the class
EV1 = ElectricVehicle("EV", "EV", 3.5, 3.5, 300, [0.0, 8.30], ev1P, PUev1, Pev1, cev, batteryEV1)
EV2 = ElectricVehicle("EV", "EV", 3.5, 3.5, 300, [17.0, 24.0], ev2P, PUev2, Pev2, cev, batteryEV2)
print("Instances of the class ElectricVehicle are EV1 and EV2")
#
#SMART METER:
#let's first take care of Pmustrun: the aggregator buys energy at every instant to cover the must run power consumption
for hour in range(len(timeframe)):
    if hour == 0:
        hydropower.initialisation(hour, 382e6)
    if timeframe[hour] == EV1.timelimits(0):
        EV1.initialisation(hour, 15)
        EV1.condition = "waiting"
    if timeframe[hour] == EV2.timelimits(0):
        EV2.initialisation(hour, 5)
        EV2.condition = "waiting"
    print("hour:", timeframe[hour])
    #for each instant t, the aggregator will...
    #...create a list of the appliances to use depending on their role...
    flexApplist = []
    runApplist = []
    for app in [dishwasher, wash, EV1, EV2]:
        if app.condition == "waiting":
            if app.apptype == "EV":
                if timeframe[hour] == app.timelimits(1) - ceil10((app.duration - app.battery[hour]/app.power)):
                    app.ON(hour, app.battery[hour]/app.power)
                    runApplist.append(app)
                elif (timeframe[hour] == 1440 - ceil10((app.duration - app.battery[hour]/app.power))):
                    app.ON(hour, app.battery[hour]/app.power)
                    runApplist.append(app)
                elif timeframe[hour] == app.timelimits(1):
                    app.disconnect(hour)
                else:
                    flexApplist.append(app)
            else:
                if timeframe[hour] == app.timelimits(1) - app.duration:
                    app.ON(hour, 0)
                    runApplist.append(app)
                elif timeframe[hour] == 1440 - app.duration:
                    app.ON(hour, 0)
                    runApplist.append(app)
                elif timeframe[hour] == app.timelimits(1):
                    app.condition == "passive"
                else:
                    flexApplist.append(app)     
        elif app.condition == "passive":
            if timeframe[hour] == app.timelimits(0):
                app.condition = "waiting"
                flexApplist.append(app)
            if app.apptype == "EV":
                app.disconnect(hour)
        elif app.condition == "running":
            if app.powerlist[hour] == -1:
                if app.apptype == "EV":
                    app.powerlist[hour] = 0
                    if timeframe[hour] == app.timelimits(1):
                        app.disconnect(hour)
                        app.condition = "passive"
                    else:
                        app.condition = "waiting"
                        flexApplist.append(app)
                else:
                        app.OFF(hour)
            else:
                runApplist.append(app)
    #...sort the costs of each energy source from the lowest to the highest..
    resources = [[solarpower, solarpower.costlist[hour]], [windpower, windpower.costlist[hour]], [hydropower, hydropower.costlist[hour]], [mgpower, mgpower.costlist[hour]]]
    for car in [EV1, EV2]:
        if car.condition == "waiting":
            resources.append([car, car.costlist[hour]])
    mincost = sorted(resources, key=itemgetter(1))
    #...create a local variable P_mustrun...
    P_mustrun = mustrun.powerlist[hour]
    print("P_mustrun_initiate =", P_mustrun)
    #...cover P_mustrun with the cheapest energy source -and the second cheapest if needed, ...
    while (P_mustrun>0):
        for resource in mincost:
            print(resource[0].resourcetype)
            if isinstance(resource[0], Storage):
                if resource[0].resourcetype == "EV":
                    flexApplist.remove(resource[0])
                if P_mustrun <= resource[0].PAlist[hour]:
                    resource[0].createResourceUse(hour, P_mustrun)
                    resource[0].updatebattery(hour, -P_mustrun)
                    resource[0].updatePower(hour, -P_mustrun)
                    P_mustrun = 0
                elif P_mustrun > resource[0].PAlist[hour]:
                    resource[0].createResourceUse(hour, resource[0].PAlist[hour])
                    P_mustrun -= resource[0].PAlist[hour]
                    resource[0].updatebattery(hour, -resource[0].PAlist[hour])
                    resource[0].updatePower(hour, -resource[0].PAlist[hour])
            else:
                if P_mustrun <= resource[0].PAlist[hour]:
                    resource[0].createResourceUse(hour, P_mustrun)
                    resource[0].updatePower(hour, - P_mustrun)
                    P_mustrun = 0
                elif P_mustrun > resource[0].PAlist[hour]:
                    resource[0].createResourceUse(hour, resource[0].PAlist[hour])
                    P_mustrun -= resource[0].PAlist[hour]
                    resource[0].updatePower(hour, -resource[0].PAlist[hour])
        else:
            if P_mustrun>0:
                print("ERROR: the energy production was not enough to cover for P_mustrun at time ", hour)
                P_mustrun=0
    print("final P_mustrun", P_mustrun)
    #....cover the appliances that have started to run....
    if runApplist != []:
        mincost = sorted(resources, key=itemgetter(1))
        for app in runApplist:
            P_runapp = app.powerlist[hour]
            while (P_runapp > 0):
                for resource in mincost:
                    print(resource[0].resourcetype)
                    if isinstance(resource[0], Storage):
                        if resource[0] in flexApplist:
                            flexApplist.remove(resource[0])
                        if P_runapp <= resource[0].PAlist[hour]:
                            resource[0].createResourceUse(hour, P_runapp)
                            resource[0].updatebattery(hour, -P_runapp)
                            resource[0].updatePower(hour, -P_runapp)
                            P_runapp = 0
                        elif P_runapp > resource[0].PAlist[hour]:
                            resource[0].createResourceUse(hour, resource[0].PAlist[hour])
                            P_runapp -= resource[0].PAlist[hour]
                            resource[0].updatebattery(hour, -resource[0].PAlist[hour])
                            resource[0].updatePower(hour, -resource[0].PAlist[hour])
                    else:
                        if P_runapp <= resource[0].PAlist[hour]:
                            resource[0].createResourceUse(hour, P_runapp)
                            resource[0].updatePower(hour, - P_runapp)
                            P_runapp = 0
                        elif P_runapp > resource[0].PAlist[hour]:
                            resource[0].createResourceUse(hour, resource[0].PAlist[hour])
                            P_runapp -= resource[0].PAlist[hour]
                            resource[0].updatePower(hour, -resource[0].PAlist[hour])
                else:
                    if P_runapp>0:
                        print("ERROR: the energy production was not enough to cover for P_run{} at time {} ".format(app.apptype, timeframe[hour]))
                        P_runapp = 0
            if app.apptype == "EV":
                app.updatebattery(hour, app.power)
            print("final P_runapp", P_runapp)
    else:
      print("There are no running appliances at time", timeframe[hour])
    #...and finally trigger the flexible appliances...
    while flexApplist != []:
        c_mean = 0
        PA_tot = 0
        for resource in resources:
            c_mean += resource[0].PAlist[hour] * resource[1]
            PA_tot += resource[0].PAlist[hour]
        if PA_tot > 0: #ERROR indicator
            c_mean = c_mean/PA_tot
            if c_mean < cavg[hour]: #the smart meter detects cheap prices and triggers flexible appliances
                mincost = sorted(resources, key=itemgetter(1))
                appcosts =[]
                for app in flexApplist: #the smart meter finds which flexible appliance is cheaper to trigger
                    print("appliance", app.apptype)
                    c_meanapp = 0
                    P_flexapp = app.power
                    while P_flexapp > 0:
                        for resource in mincost:
                            print(resource[0].resourcetype)
                            P_resource = resource[0].PAlist[hour]
                            if P_flexapp <= P_resource:
                                c_meanapp += resource[1] * P_flexapp
                                P_resource -= P_flexapp
                                P_flexapp = 0
                            elif P_flexapp > P_resource:
                                c_meanapp += resource[1] * P_resource
                                P_flexapp -= P_resource
                                P_resource = 0
                            print("new P_flexapp", P_flexapp)
                            if P_flexapp == 0:
                                break
                    c_meanapp = c_meanapp / app.power
                    appcosts.append([app, c_meanapp])
                flexmin = min(appcosts, key=itemgetter(1))
                print("min", flexmin)
                if flexmin[0].apptype == "EV": #the smart meter triggers the flexible appliance
                    flexmin[0].ON(hour, flexmin[0].battery[hour]/flexmin[0].power) 
                    resources.remove([flexmin[0], flexmin[0].costlist[hour]])
                else:
                    flexmin[0].ON(hour, 0)
                P_flexmin = flexmin[0].powerlist[hour]
                while (P_flexmin > 0):
                    for resource in mincost:
                        print(resource[0].resourcetype)
                        if isinstance(resource[0], Storage):
                            if resource[0] in flexApplist:
                                flexApplist.remove(resource[0])
                            if P_flexmin <= resource[0].PAlist[hour]:
                                resource[0].createResourceUse(hour, P_flexmin)
                                resource[0].updatebattery(hour, -P_flexmin)
                                resource[0].updatePower(hour, -P_flexmin)
                                P_flexmin = 0
                            elif P_flexmin > resource[0].PAlist[hour]:
                                resource[0].createResourceUse(hour, resource[0].PAlist[hour])
                                P_flexmin -= resource[0].PAlist[hour]
                                resource[0].updatebattery(hour, -resource[0].PAlist[hour])
                                resource[0].updatePower(hour, -resource[0].PAlist[hour])
                        else:
                            if P_flexmin <= resource[0].PAlist[hour]:
                                resource[0].createResourceUse(hour, P_flexmin)
                                resource[0].updatePower(hour, - P_flexmin)
                                P_flexmin = 0
                            elif P_flexmin > resource[0].PAlist[hour]:
                                resource[0].createResourceUse(hour, resource[0].PAlist[hour])
                                P_flexmin -= resource[0].PAlist[hour]
                                resource[0].updatePower(hour, -resource[0].PAlist[hour])
                    else:
                        if P_flexmin>0:
                            print("ERROR: the energy production was not enough to cover for P_flex{} at time {} ".format(flexmin[0].apptype, timeframe[hour]))
                            P_flexmin = 0
                if flexmin[0].apptype == "EV":
                    flexmin[0].updatebattery(hour, flexmin[0].power)
                #print("flexapplist", flexApplist)  
                flexApplist.remove(flexmin[0]) 
            else:
                print("Prices are not interesting enough to trigger flexible appliances")
                break
        else:
            print("ERROR: No more power is available for flexibility")
    if EV1 in flexApplist:
        EV1.updatebattery(hour, 0)
    if EV2 in flexApplist:
        EV2.updatebattery(hour, 0)
    print("There are no more flexible appliances") 
#Simulation is complete !
print("Simulation complete")
#cost of energy at each time of the day
Finalcost = []
for instant in range(len(timeframe)):
    Finalcost.append(0)
for instant in range(len(timeframe)):
    for resource in [solarpower, windpower, hydropower, mgpower, EV1, EV2]:
        Finalcost[instant] += resource.costlist[instant] * resource.PUlist[instant]
#total cost of the day
Costday = 0
for instant in range(len(timeframe)):
    Costday += Finalcost[instant]
print("costday", Costday)
print(PUwind)
# #
#SAVING RESULTS IN DATABASE
conn=sqlite3.connect('C:/Python34/data/mydb.db')
cursor=conn.cursor()
#no need to save the updated power vailable, the original values are more interesting for further study
#Power Use of energy resources
for instant in range(len(timeframe)):
    cursor.execute("""UPDATE PowerUse SET P_solar = ? WHERE Time=  ?""", (solarpower.PUlist[instant], timeframe[instant]))
    cursor.execute("""UPDATE PowerUse SET P_wind = ? WHERE Time=  ?""", (windpower.PUlist[instant], timeframe[instant]))
    cursor.execute("""UPDATE PowerUse SET P_hydro = ? WHERE Time=  ?""", (hydropower.PUlist[instant], timeframe[instant]))
    cursor.execute("""UPDATE PowerUse SET P_maingrid = ? WHERE Time=  ?""", (mgpower.PUlist[instant], timeframe[instant]))
    cursor.execute("""UPDATE PowerUse SET P_ev = ? WHERE Time=  ?""", (EV1.PUlist[instant]+EV2.PUlist[instant], timeframe[instant])) 
conn.commit()
#battery levels
for instant in range(len(timeframe)):
    cursor.execute("""UPDATE BatteryLevel SET HYDRO = ? WHERE Time=  ?""", (hydropower.battery[instant], timeframe[instant]))
    if type(EV1.battery[instant]) is str:
        if type(EV2.battery[instant]) is str:
            cursor.execute("""UPDATE BatteryLevel SET EV = ? WHERE Time=  ?""", ("NA", timeframe[instant]))
        else:
            cursor.execute("""UPDATE BatteryLevel SET EV = ? WHERE Time=  ?""", (EV2.battery[instant], timeframe[instant]))
    if type(EV2.battery[instant]) is str:
        if type(EV1.battery[instant]) is str:
            cursor.execute("""UPDATE BatteryLevel SET EV = ? WHERE Time=  ?""", ("NA", timeframe[instant]))
        else:
            cursor.execute("""UPDATE BatteryLevel SET EV = ? WHERE Time=  ?""", (EV1.battery[instant], timeframe[instant]))
conn.commit()
#Energy Consumption
for instant in range(len(timeframe)):
    cursor.execute("""UPDATE EnergyConsumption SET P_dishwasher = ? WHERE Time=  ?""", (dishwasher.powerlist[instant], timeframe[instant]))
    cursor.execute("""UPDATE EnergyConsumption SET P_wash = ? WHERE Time=  ?""", (wash.powerlist[instant], timeframe[instant]))
    cursor.execute("""UPDATE EnergyConsumption SET P_ev = ? WHERE Time=  ?""", (EV1.powerlist[instant]+EV2.powerlist[instant], timeframe[instant]))
conn.commit()      
conn.close()  
#
#PRINT GRAPHS
import matplotlib.pyplot as plt
#first the timeframe can be adjusted to a more readable format..
for hour in range(len(Pmg)):
    timeframe[hour] = int(timeframe[hour]/60)+((timeframe[hour]/60-int(timeframe[hour]/60))*60)/100
#Power production
#weighted the solar production for the city
Psolarcity = []
for hour in range(len(timeframe)):
    Psolarcity.append(Psolar0[hour]*100000)
fig, ax = plt.subplots()
ax.plot(timeframe, Psolarcity, label='Solar Power production for the city in kW')
ax.plot(timeframe, Pwind0, label='Wind Power production in kW')
legend = ax.legend()
fig.savefig('C:/Python34/data/results/variableproduction.png')
plt.close(fig)
#Power Uses
fig, ax = plt.subplots()
ax.plot(timeframe, solarpower.PUlist, label='Solar Power Use in kW')
ax.plot(timeframe, windpower.PUlist, label='Wind Power Use in kW')
ax.plot(timeframe, hydropower.PUlist, label='Hydro Power Use in kW')
ax.plot(timeframe, mgpower.PUlist, label='Main grid Power Use in kW')
legend = ax.legend()
fig.savefig('C:/Python34/data/results/PowerUse.png')
plt.close(fig)
#Battery Levels
EVbatt = []
for instant in range(len(timeframe)):
    if type(EV1.battery[instant]) is str:
        if type(EV2.battery[instant]) is str: 
            EVbatt.append(0)
        else:
            EVbatt.append(EV2.battery[instant])
    elif type(EV2.battery[instant]) is str: 
        if type(EV1.battery[instant]) is str: 
            EVbatt.append(0)
        else:
            EVbatt.append(EV1.battery[instant])
    else:
        EVbatt.append(EV1.battery[instant]+EV2.battery[instant])
plt.figure(1)
plt.subplot(211)
plt.plot(timeframe, EVbatt, label='Ev battery level in kWh')

plt.subplot(212)
plt.plot(timeframe, hydropower.battery, label='Hydropower reservoir level in kWh')
legend = ax.legend()
plt.savefig('C:/Python34/data/results/BatteryLevel.png')
plt.close(fig)
#Power Consumption
EVpower = []
for instant in range(len(timeframe)):
    EVpower.append(EV1.powerlist[instant]+EV2.powerlist[instant])
fig, ax = plt.subplots()
ax.plot(timeframe, mustrun.powerlist, label='Must-run Appliances in kW')
ax.plot(timeframe, dishwasher.powerlist, label='Dishwasher Use in kW')
ax.plot(timeframe, wash.powerlist, label='Washing Appliances Use in kW')
ax.plot(timeframe, EVpower, label='EV use in kW')
legend = ax.legend()
fig.savefig('C:/Python34/data/results/Appliances.png')
plt.close(fig)
#Costs
fig, ax = plt.subplots()
ax.plot(timeframe, csolar, label='Cost of solar energy in NOK/kWh')
ax.plot(timeframe, cwind, label='Cost of wind energy in NOK/kWh')
ax.plot(timeframe, chydro, label='Cost of hydro energy in NOK/kWh')
ax.plot(timeframe, cmg, label='Cost of main grid energy in NOK/kWh')
ax.plot(timeframe, cev, label='Equivalent cost of EV storage in NOK/kWh')
legend = ax.legend()
fig.savefig('C:/Python34/data/results/costs.png')
plt.close(fig)
#final cost
fig, ax = plt.subplots()
ax.plot(timeframe, Finalcost, label='Price spent on energy in NOK')
legend = ax.legend()
fig.savefig('C:/Python34/data/results/Finalcost.png')
plt.close(fig)
#power resources
#solar
fig, ax = plt.subplots()
ax.plot(timeframe, Psolar0, label='Solar power production in kW')
ax.plot(timeframe, solarpower.PUlist, label='Solar power use in kW')
legend = ax.legend()
fig.savefig('C:/Python34/data/results/solarpower.png')
plt.close(fig)
#wind.
PwMW = []
for hour in range(len(timeframe)):
    PwMW.append(Pwind0[hour]/1000)
fig, ax = plt.subplots()
ax.plot(timeframe, PwMW, label='Wind power production in MW')
ax.plot(timeframe, windpower.PUlist, label='Wind power use in kW')
legend = ax.legend()
fig.savefig('C:/Python34/data/results/windpower.png')
plt.close(fig)