DROP TABLE PV;
DROP TABLE Wind;
DROP TABLE ProdStatnett;
DROP TABLE ConsAuburn;
DROP TABLE PriceMG;
CREATE TABLE PV(
    Time REAL,
    SolarPowerkW REAL);
.mode csv
.import C:/Python34/data/solarresourcedata17.06-10min_noheaders.csv PV
CREATE TABLE Wind(
    Time REAL,
    WindPowerkW REAL);
.mode csv
.import C:/Python34/data/windresourcedata3x12.06-10min_noheaders.csv Wind
CREATE TABLE ProdStatnett(
    Time REAL,
    ProductionkW REAL);
.import C:/Python34/data/productionconsumption11.04-10min_noheaders.csv ProdStatnett
CREATE TABLE ConsAuburn(
    Time REAL,
    ConsumptionkW REAL);
.import C:/Python34/data/consumptionAuburn_08.04-10min_noheaders.csv ConsAuburn
CREATE TABLE PriceMG(
    Time REAL,
    PriceNOKkWh REAL);
.import C:/Python34/data/systemprice19.02-10min_noheaders.csv PriceMG
.mode column
.headers on
.width 10
SELECT * FROM PV;
SELECT * FROM Wind;
SELECT * FROM ProdStatnett;
SELECT * FROM ConsAuburn;
SELECT * FROM PriceMG;
